package com.loganmagnan.eventcore.managers.event;

import com.loganmagnan.eventcore.managers.event.teams.Team;
import com.loganmagnan.eventcore.utils.CustomLocation;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import java.util.List;

@Getter
@Setter
@AllArgsConstructor
@RequiredArgsConstructor
public class Event {

    // General Information
    private String name;
    private CustomLocation spawnPoint;
    private int duration;

    // Teams Information
    private List<Team> teams;
    private int amountOfTeams;
    private int amountPerTeam;
    private List<CustomLocation> teamSpawnPoints;

    // Toggleable Settings
    private boolean scoreboardEnabled;
    private boolean timerEnabled;
    private boolean eventsEnabled;

    // Events
    // BlockPlaceEvent
    private boolean blockPlaceEventEnabled;

    // BlockBreakEvent
    private boolean blockBreakEventEnabled;

    // Other
    private boolean started;
}
